#include <fxlib.h>
#include "File.h"
#include "MonochromeLib.h"

static list all_files[NB_FILES_MAX];

int User_Choose_File(const FONTCHARACTER path_name_base[], FONTCHARACTER path_name[], FONTCHARACTER File[], int path_name_size, opt_tri tri, int show_folder, int search_directory) {
	FONTCHARACTER path_name_dossiers[100] = {0};
	unsigned int key;
	FILE_INFO infos_file;
	char folder[50] = "SD:", folder_size = 3;
	int nb_elements, h, i, j, k, handle, fichier_choisi_ok = 0, end_path_name_base, nb_dossiers;
	
	
	//	ANALYSE DE PATH_NAME_BASE ET COPIE DANS PATH_NAME
	
	for (i = 0; i < path_name_size; i ++)
		path_name[i] = 0;
	
	end_path_name_base = 0;
	while (path_name_base[end_path_name_base] != '\0')
		end_path_name_base ++;
	
	for (i = 0; i <= end_path_name_base; i ++)
		path_name[i] = path_name_base[i];
	
	while (path_name_base[end_path_name_base] != '\\')
		end_path_name_base --;
	
	
	//	SI ON DOIT MONTRER LE CHEMIN D'ACCÈS EN HAUT DE L'AFFICHAGE DES FICHIERS
	
	if (show_folder) {
		if (path_name_base[2] == 'f') {
			folder[0] = 'S';
			folder[1] = 'T';
			folder[2] = 'O';
			folder[3] = ':';
			folder_size = 4;
		}
		if (end_path_name_base > 6) {
			j = end_path_name_base-1;
			while(path_name_base[j] != '\\') j--;
			for(i = j+1; i < end_path_name_base; i++){
				folder[folder_size] = path_name_base[i];
				folder_size++;
			}
			folder[folder_size] = path_name_base[i];
			folder_size++;
		}
	}
	

	do {
		nb_dossiers = 0;

		if(search_directory) {
			//	INITIALISE LE FONTCHARACTER DE RECHERCHE POUR LES DOSSIERS

			i = 0;
			while(path_name[i]) i ++;
			while(path_name[i] != '\\') i --;
			for(j = 0; j <= i; j ++) path_name_dossiers[j] = path_name[j];
			path_name_dossiers[j] = '*';
			path_name_dossiers[j + 1] = 0;


			//	RECHERCHE DES DOSSIERS QUEL QUE SOIT LE CHEMIN D'ACCÈS EN COURS

			for (j = 0; j < 13; j ++)															//	Initialise le nom du premier fichier
				all_files[0].name[j] = '\0';

			if (Bfile_FindFirst(path_name_dossiers, &handle, all_files[0].name, &infos_file) >= 0) {	//	Lance la recherche des fichiers
				if (infos_file.type == DT_DIRECTORY) {													//	Si c'est un dossier
					Crochets_Dossiers(0, tri);																//	Ajoute des crochets [] autour du nom qu'on vient de trouver
					nb_dossiers ++;
				}
			}
			for (i = 1; i < NB_FILES_MAX; i ++) {												//	Boucle qui incrémente i juqu'à ce qu'on soit arrivé au nombre maximum de fichiers à charger. i démarre à 1, car on a déjà recherché le premier fichier
				for (j = 0; j < 13; j ++)															//	Initialise le nom du fichier
					all_files[nb_dossiers].name[j] = '\0';
				if ( Bfile_FindNext(handle, all_files[nb_dossiers].name, &infos_file) < 0)			//	Recherche le second fichier
					break;																				//	Si la recherche a échoué ou si il n'y a plus de fichiers à trouver, quitte la boucle
				if (infos_file.type == DT_DIRECTORY) {												//	Si c'est un dossier
					Crochets_Dossiers(nb_dossiers, tri);			 									//	Ajoute des crochets [] autour du nom qu'on vient de trouver
					nb_dossiers ++;
				}
			}
			Bfile_FindClose(handle);														//	Ferme la recherche
		}


		//	RECHERCHE DES FICHIERS PRÉSENTS DANS LE RÉPERTOIRE POINTÉ PAR PATH_NAME
		
		nb_elements = 0;
		for (j = 0; j < 13; j ++)															//	Initialise le nom du premier fichier
			all_files[nb_dossiers].name[j] = '\0';
		if (Bfile_FindFirst(path_name, &handle, all_files[nb_dossiers].name, &infos_file) >= 0) {		//	Lance la recherche des fichiers
			if (infos_file.type != DT_DIRECTORY) {											//	Si c'est un fichier
				all_files[nb_dossiers].size = infos_file.dsize;									//	Stocke sa taille
				nb_elements ++;
			}
		}
		for (i = nb_dossiers; i < NB_FILES_MAX; i ++) {										//	Boucle qui incrémente i juqu'à ce qu'on soit arrivé au nombre maximum de fichiers à charger. i démarre à nb_dossiers, car on a déjà recherché les dossiers
			for (j = 0; j < 13; j ++)															//	Initialise le nom du fichier
				all_files[nb_elements+nb_dossiers].name[j] = '\0';
			if ( Bfile_FindNext(handle, all_files[nb_elements+nb_dossiers].name, &infos_file) < 0)	//	Recherche le second fichier
				break;																				//	Si la recherche a échoué ou si il n'y a plus de fichiers à trouver, quitte la boucle
			if (infos_file.type != DT_DIRECTORY) {												//	Si c'est un fichier
				all_files[nb_elements+nb_dossiers].size = infos_file.dsize;							//	Stocke sa taille
				nb_elements ++;
			}
		}
		Bfile_FindClose(handle);															//	Ferme la recherche
		nb_elements += nb_dossiers;


		//	TRI DES FICHIERS
		
		nb_dossiers = 0;
		if ( (nb_elements) && (tri != AUCUN_TRI) ){
			i = 0;
			while (i != nb_elements) {
				if (tri != DOSSIERS_DEVANT) {
					k = 0;
					for (j = 0; j < nb_elements; j ++) if (Superior(i, j, tri)) k++;
					if (i != k) {
						if (tri == DOSSIERS_DEVANT_ORDRE_ALPHABETIQUE) {
							Swap_Files(i, k);
							i --;
						}
						else if ( (k >= nb_dossiers) && (all_files[i].size != all_files[k].size) ) {
							Swap_Files(i, k);
							i --;
						}
						else nb_dossiers ++;
					}
				}
				else {
					if ( (i == 0) && (all_files[0].name[0] == '[') )
						nb_dossiers ++;
					else if (all_files[i].name[0] == '[') {
						Swap_Files(i, nb_dossiers);
						nb_dossiers ++;
					}
				}
				i ++;
			}
		}
		
		
		//	AFFICHAGE DES RÉSULTATS
		
		i = 0;																		//	i devient maintenant l'indicateur du premier fichier affiché à l'écran
		h = show_folder;															//	h représente la position du rectangle de sélection	
		do {																		//	Début de l'affichage
			ML_clear_vram();
			if (show_folder) {
				PrintXY(0, 0, folder, 0);
				ML_rectangle(0, 0, 6 * folder_size, 7, 0, 0, ML_XOR);
			}
			
			if (nb_elements) {
				for (j = show_folder; j < 8; j ++) {										//	Affiche 1 par 1 tous les fichiers sur l'écran
					if (j + i == nb_elements + show_folder) break;								//	Si tu affiche plus de fichiers que ceux que tu as chargé, quitte la boucle
					Afficher_FONTCHARACTER(all_files[j + i - show_folder].name, 0, 8 * j);		//	Affiche le nom du fichier
					if (all_files[j + i - show_folder].name[0] != '[')							//	Si le nom affiché ne correspond pas à un dossier
						Afficher_Nombre(all_files[j + i - show_folder].size, 84, 8 * j);			//	Affiche sa taille
				}
				if (i)																		//	Si tu peux monter l'affichage
					PrintXY(122, 8 * show_folder, "\xe6\x92", 0);								//	Flèche du haut
				if ( (i != nb_elements - 8 + show_folder) && (nb_elements > 8 - show_folder) )	//	Si tu peux descendre l'affichage
					PrintXY(122, 56, "\xe6\x93", 0);											//	Flèche du bas
				ML_rectangle(0, h * 8, 127, h * 8 + 7, 0, 0, ML_XOR);						//	Rectangle de sélection
			}
			else PrintXY(0, 10 * show_folder, "No Files", 0);
			
			GetKey( &key );
			
			if (nb_elements) {	
				if (key == KEY_CTRL_DOWN) {													//	Touche du bas
					if (nb_elements < 9 - show_folder) {										//	S'il y a moins de 9 fichiers chargés
						h ++;																		//	Descend le rectangle
						if (h == nb_elements + show_folder)	h = show_folder;						//	S'il est tout en bas, remet le rectangle tout en haut
					}
					else {																		//	Si tous les fichiers ne rentrent pas dans l'écran (supérieur à 8 fichiers)
						if (h != 7) h ++;															//	Descend le rectangle
						else if (i != nb_elements - 8 + show_folder) i ++;							//	Sinon, descend tout l'affichage
						else if (i == nb_elements - 8 + show_folder) {								//	Si on est arrivé au bout des fichiers
							i = 0;																		//	Remet l'affichage à zéro
							h = show_folder;															//	Remet le rectangle tout en haut de la liste
						}
					}
				}																			//	Fin "Touche du bas"
				
				else if (key == KEY_CTRL_UP) {												//	Touche du haut
					if (nb_elements < 9 - show_folder) {										//	S'il y a moins de 9 fichiers chargés
						h --;																		//	Monte le rectangle
						if (h == show_folder - 1)	h = nb_elements - 1 + show_folder;				//	S'il est déjà tout en haut, met le rectangle tout en bas
					}
					else {																		//	Si tous les fichiers ne rentrent pas dans l'écran (supérieur à 8 fichiers)
						if (h != show_folder) h --;													//	Monte le rectangle
						else if (i) i --;															//	Sinon, monte tout l'affichage
						else if (i == 0) {															//	Si on est arrivé tout en haut de la liste des fichiers chargés
							i = nb_elements - 8 + show_folder;											//	Met l'affichage tout en bas
							h = 7;																		//	Met le rectangle tout en bas
						}
					}
				}																			//	Fin "Touche du haut"
			}
		} while ( ((key!=KEY_CTRL_EXE)||(!nb_elements)) && (key != KEY_CTRL_EXIT) );	//	Continue à afficher les fichiers trouvés tant qu'on a pas [EXE] ni [EXIT]
		
		
		if (key == KEY_CTRL_EXE) {													//	Si on a appuyé sur [EXE]
			if (all_files[i + h - show_folder].name[0] == '[') {						//	Sur un dossier
				k = 0;
				while (path_name[k] != '\0')												//	k vaut le nombre de caractères dans path_name
					k ++;
				while (path_name[k] != '\\')												//	k correspond à la place dans path_name du dernier '\\' rencontré
					k --;
				j = 1;
				while (all_files[i + h - show_folder].name[j] != ']') {						//	Copie le nom du dossier (sans les crochets) dans path_name à partir de k
					path_name[k + j] = all_files[i + h - show_folder].name[j];
					j ++;
				}
				h += i;
				i = 0;
				while (path_name_base[end_path_name_base + i - 1] != '\0') {				//	Copie la fin de path_name_base (à partir de end_path_name_base) dans path_name (à partir de k + j)
					path_name[k + j + i] = path_name_base[end_path_name_base + i];
					i ++;
				}																			//	À l'issue de ce processus, on a inséré le nom du dossier dans le profil de recherche (path_name)
				
				if (show_folder) {
					k = 0;
					while (folder[k] != '\0')												//	k vaut le nombre de caractères de folder
						k ++;
					while ( (folder[k] != '\\') && (folder[k] != ':') )						//	k correspond à la place dans folder du dernier '\\' ou ':' rencontré
						k --;
					j = 1;
					while (all_files[h - 1].name[j] != ']') {
						folder[j + k] = all_files[h - 1].name[j];
						j ++;
					}
					folder[j + k] = '\\';
					folder[j + k + 1] = '\0';
				}
			}
			else																		//	Sur un fichier
				fichier_choisi_ok = 1;														//	Quitte la boucle de sélection du fichier parce qu'on a enfin choisi un fichier
		}																			//	Fin touche [EXE]
		
		else {																		//	Sinon, si on a appuyé sur [EXIT]
			k = 0;
			while (path_name[k] != '\0')
				k ++;
			while (path_name[k] != '\\')												//	k contient la place du premier caractère '\\' rencontré dans path_name en partant de la fin
				k --;
			k --;
			while ( (path_name[k] != '\\') && (k != 1) )								//	k contient la place du deuxième caractère '\\' rencontré dans path_name en partant de la fin
				k --;
			if(k > 1) {																	//	Si k est supérieur à 1 → Si le dossier actuel est un sous-dossier
				i = 0;
				while (path_name_base[end_path_name_base + i - 1] != '\0') {				//	Copie la fin de path_name_base (à partir de end_path_name_base) dans path_name (à partir de k)
					path_name[k + i] = path_name_base[end_path_name_base + i];
					i ++;
				}
				
				if (show_folder) {
					k = 0;
					while (folder[k] != '\0')												//	k vaut le nombre de caractères de folder
						k ++;
					k -= 2;
					while ( (folder[k] != '\\') && (folder[k] != ':') )						//	k correspond à la place dans folder du deuxième '\\' ou ':' rencontré à partir de la fin
						k --;
					folder[k + 1] = '\0';
				}
			}
			else return 1;																//	Retourne 1 → Quitte parce que [EXIT] du dossier racine
		}																			//	Fin de la touche [EXIT]
		
		if (show_folder) {
			folder_size = 0;
			while (folder[folder_size] != '\0')
				folder_size ++;
		}
		
	} while (!fichier_choisi_ok);
	
	j = 0;
	while (all_files[i + h - show_folder].name[j] != '\0') {
		File[j] = all_files[i + h - show_folder].name[j];
		j ++;
	}
	File[j] = '\0';
	
	j = 0;
	while (path_name[j] != '\0')
		j++;
	while (path_name[j] != '\\')
		j --;
	path_name[j + 1] = '\0';
	return 0;
}

void Afficher_FONTCHARACTER(FONTCHARACTER *str, int x, int y) {			//	Cette fonction affiche une chaîne FONTCHARACTER aux coordonnées x et y
	int i;
	char str_converted[110] = "";
	
	for(i = 0; str[i]; i ++)
		str_converted[i] = str[i];
	
	PrintXY(x, y, str_converted, 0);
}
int Afficher_Nombre(long n, int x, int y){								//	Cette fonction affiche un long aux coordonnées x et y
	char s[20]="";
	long i,j,sign;
	char c;
	if((sign=n)<0) n=-n;
	i=0;
	do{
		s[i++]=n%10+'0';
	}while((n/=10)>0);
	if(sign<0)
	s[i++]='-';
	s[i]='\0';
	for(i=0,j=strlen(s)-1;i<j;i++,j--){
		c=s[i];
		s[i]=s[j];
		s[j]=c;
	}
	
	PrintXY(x, y, s, 0);
	return strlen(s);
}
void Crochets_Dossiers(int i, opt_tri tri) {											//	Cette fonction ajoutes des crochets [] autour du i-ème nom de all_files
	int j, h;
	for (j = 0; j < 13; j ++)
		if ( all_files[i].name[j] == 0 ) break;
	for (h = j - 1; h >= 0; h --)
		all_files[i].name[h + 1] = all_files[i].name[h];
	all_files[i].name[0] = '[';
	all_files[i].name[j + 1] = ']';
	if(tri == TAILLE_DECROISSANT) all_files[i].size = 100000;
	else all_files[i].size = -1;
}
void Swap_Files(int f1, int f2) {
	FONTCHARACTER name_3[13];
	int i = 0;
	unsigned int key;
	long size_3;
	
	while (all_files[f1].name[i] != '\0') {
		name_3[i] = all_files[f1].name[i];
		i ++;
	}
	name_3[i] = '\0';
	i = 0;
	while (all_files[f2].name[i] != '\0') {
		all_files[f1].name[i] = all_files[f2].name[i];
		i ++;
	}
	all_files[f1].name[i] = '\0';
	i = 0;
	while (name_3[i] != '\0') {
		all_files[f2].name[i] = name_3[i];
		i ++;
	}
	all_files[f2].name[i] = '\0';
	
	size_3 = all_files[f1].size;
	all_files[f1].size = all_files[f2].size;
	all_files[f2].size = size_3;
}
int Superior (int f1, int f2, opt_tri tri) {
	int i = 0, a, b;
	if (f1 == f2) return 0;
	
	if (tri == DOSSIERS_DEVANT_ORDRE_ALPHABETIQUE) {
		while ( abs_Lettre(all_files[f1].name[i]) == abs_Lettre(all_files[f2].name[i]) )
			i ++;
		if ( abs_Lettre(all_files[f1].name[i]) > abs_Lettre(all_files[f2].name[i]) ) return 1;
		return 0;
	}
	
	if (tri == TAILLE_CROISSANT) {
		if (all_files[f1].size > all_files[f2].size) return 1;
		return 0;
	}
	if (tri == TAILLE_DECROISSANT) {
		if (all_files[f1].size < all_files[f2].size) return 1;
		return 0;
	}
}
int abs_Lettre(char a) {
	if ( (a >= 'a') && (a <= 'z') )
		a -= 32;
	if (a == '[') a = 128;
	return a;
}
void FONTCHARACTER_cat(const FONTCHARACTER ch1[], const FONTCHARACTER ch2[], FONTCHARACTER ch3[]) {	//	Concatène les deux chaînes de FONTCHARACTER données en argument dans ch3[]
	int i = 0, j = 0;
	while(ch1[i]) {
		ch3[i] = ch1[i];
		i++;
	}
	while(ch2[j]) {
		ch3[i+j] = ch2[j];
		j++;
	}
	ch3[i+j] = 0;
}
